c     FORTRAN77 code
c     File: tlssim.for
c
c     This program is intended for nonlinear error correction models
c     It checks the estimation power of TSLS method for TVECM
c     Created  by Antoni Vidiella
c     GRID SEARCH
c
c     Current setting
c
c     Number-variables = 2
c     max-ar-p = 29
c     max-obs  = 250
c     maximum number of regimes = 5
c
ccccc Definition of variables
c
      implicit real*8 (a-h,o-z)
      parameter(nmax=250,ipmax=5)
      dimension dat(nmax,ipmax),rnn(ipmax),elp2(ipmax,ipmax)
      dimension dat2(nmax,ipmax),dat3(nmax,ipmax),dat4(nmax,ipmax)
      dimension y1(nmax,ipmax),x1(nmax,ipmax),x2(ipmax,nmax)
      dimension x3(ipmax,ipmax),x4(ipmax,ipmax),x5(nmax,ipmax)
      dimension x6(ipmax,2),x7(nmax,2),x8(nmax,2),zj(nmax,ipmax)
      dimension elp1(ipmax,ipmax),hreg(ipmax,ipmax,2)
      dimension bcan(1000),post(1000),x18(nmax,2)
      dimension desv1(ipmax),c1(ipmax),w(nmax),z(nmax,ipmax)
      dimension det1(1000,1000),x9(ipmax,ipmax),x10(nmax,ipmax)
      dimension ri(250),x41(ipmax,1),var(ipmax),cn(ipmax,ipmax)
      dimension x43(ipmax,1),dat5(1000+nmax,ipmax),d1(nmax)
      dimension err1(1000),h1(ipmax,ipmax),wk(2,2)
      dimension zzj(nmax,ipmax),zzj1(ipmax,nmax),x11(ipmax,ipmax)
      dimension x12(ipmax,ipmax),x13(ipmax,2),x14(ipmax,2)
      dimension x15(nmax,2),x16(2,nmax),x17(2,2)
      dimension d8(nmax,2),d9(nmax,2),c2(ipmax),c3(ipmax)
      dimension desv2(ipmax),desv3(ipmax),w2(nmax)
c
      integer seed
      external zeromat,addmat,matinv,trnmat,multmat
      external reg,pcand,zerovec,gnorm,QCKSRT
      intrinsic dmin1
c
c
ccccc Introduction of data
c
      open (10,file='shan.res',status='unknown')
      seed=123456789
      irun=1000
      is=0
      ip=2
      nob1=250
      ierr=1
      trim=0.05
      sig=10.0
      iprec=2
      b1=1.0
      npam=2
      npamh=2
      do 153 ia=1,2
	   do 153 i=1,2
	      do 153 j=1,2
 153           hreg(i,j,ia)=0.0
      hreg(1,1,1)=-1.0
      hreg(1,2,1)=1.0
      hreg(1,1,2)=-0.5
      hreg(1,2,2)=0.5
      call zeromat(cn,ipmax,ipmax,ipmax)
      cn(1,1)=-2.0
      do 930 iv=1,irun
	 write(6,*) iv
	 nob=nob1
	 write(6,*) seed
c this decomposition is valid for the simulation
c first values are generated as a normal(0,1)
	    call gnorm(ri,10,seed)
	    dat5(1,1)=ri(5)
	    dat5(1,2)=ri(10)
	    do 192 ik=1,nob+1000
	       do 194 j=1,2
		  if (ik.gt.1) dat5(ik,j)=dat5(ik-1,j)+var(j)
 194              x41(j,1)=dat5(ik,j) 
	       err=dat5(ik,1)-b1*dat5(ik,2)
	       ia=1
	       if(err.gt.0.0) ia=2
	      CALL ZEROVEC(RI,250,10)
	      CALL GNORM(RI,10,SEED)
c agafo com a nombres aleatoris el 5 i el 10
c innovations are N(0,I2) non-correlated
	       rnn(1)=ri(5)
	       rnn(2)=ri(10)   
	       do 161 i=1,2
		  do 161 j=1,npamh
 161                 h1(i,j)=hreg(i,j,ia)
	       call zeromat(x43,ipmax,ipmax,1)
	       call multmat(h1,x41,x43,ipmax,ipmax,2,npamh,1)
	       do 171 j=1,2
 171              var(j)=x43(j,1)+rnn(j)+cn(j,ia)
	       call zeromat(x41,ipmax,ipmax,1)               
	       call zerovec(rnn,ipmax,ipmax)
	       call zeromat(h1,ipmax,ipmax,ipmax)
 192        continue
	    do 193 i=1,nob
	       do 193 j=1,2
 193              dat(i,j)=dat5(i+1000,j)
	    call zeromat(dat5,1000+nmax,1000+nob,ipmax)
	    call zeromat(dat4,nmax,nob,ipmax)
	    call zeromat(dat2,nmax,nob,ipmax)
	    call zeromat(dat3,nmax,nob,ipmax)
c in dat we have the simulated set of data, dat(i,j)
c begin of the threshold search
	  inam=10**iprec+1
	  if (ierr.eq.1) then
	      call zerovec(c1,ipmax,ipmax)
	      call zerovec(desv1,ipmax,ipmax)
	      call reg(dat,nmax,nob,c1,desv1,0)
	      call zerovec(bcan,1000,nob)
	      upl=0.0
	      bol=0.0
	      upl=c1(1)+sig*desv1(1)
	      bol=c1(1)-sig*desv1(1)
	      step=(upl-bol)/real(10**iprec)
	      bcan(1)=bol
	      do 45 im=2,10**iprec+1
 45             bcan(im)=bcan(im-1)+step
	 else
	      inam=1
	      bcan(1)=1.0
	      c1(1)=1.0
	 endif            
	 call zerovec(err1,1000,nob)
	 do 44 it=1, nob
 44         err1(it)=dat(it,1)-c1(1)*dat(it,2)
	 call zerovec(post,1000,nob)
	 ipa=400
	 if (is.eq.0) then
	      CALL QCKSRT(nob,err1)
	      up=0.0
	      bo=0.0
	      up=err1(nob)
	      bo=err1(1)
	      step=0.0
	      step=(up-bo)/real(ipa)
	      post(1)=bo
	      do 49 im=2,ipa
 49                post(im)=post(im-1)+step
	 else if(is.eq.1) then
	      ipa=0
	      call pcand(err1,nob,post,pl,pu,ipa)
	 else if(is.eq.2) then
	      open(17,file='cand.dat',status='unknown')         
	      do 491 ii=1,ipa
 491           read(17,*) post(ii)
	 endif
	 do 60 i=1,nob-ip
	      x1(i,1)=1.0
	      do 610 j=1,ip-1 
		 do 610 k=1,2
 610              x1(i,1+k+2*(j-1))=dat(ip+i-j,k)-dat(ip+i-j-1,k)
 60      continue
	 do 70 i=ip,nob
	   do 70 j=1,2
 70            y1(i-ip+1,j)=dat(i+1,j)-dat(i,j)
      icnt=nob-ip
      ior=(ip-1)*2+1
      call trnmat(x1,x2,nmax,ipmax,icnt,ior)
      call multmat(x2,x1,x3,ipmax,nmax,ior,icnt,ior)
      call matinv(x3,x4,elp1,ipmax,ior,ifail)      
      call multmat(x1,x4,x5,nmax,ipmax,icnt,ior,ior)
      call multmat(x2,y1,x6,ipmax,nmax,ior,icnt,2)
      call multmat(x5,x6,x7,nmax,ipmax,icnt,ior,2)
      call addmat(y1,x7,x8,nmax,icnt,2,-1)
      call zeromat(det1,1000,1000,1000)
      do 900 ix=1,ipa
c     iz is the index for the cointegration parameter
	 do 910 iz=1,inam
	    do 47 i=1,icnt
	       w(i)=dat(i+1,1)-bcan(iz)*dat(i+1,2)
	       z(i,1)=w(i)
	       do 47 k=1,ior
 47               z(i,1+k)=x1(i,k)
	    a1=0.0
	    call zerovec(d1,nmax,icnt)
	    do 100 it = 1,icnt
	       if(w(it).le.post(ix)) d1(it)=1.0
 100           a1=a1+d1(it)   
	    if (dmin1((a1/real(nob)),(nob-a1)/real(nob)).gt.trim) then
	       do 110 i=1,icnt
		  do 120 j=1,1+ior
 120                 zj(i,j)=z(i,j)*d1(i)
 110              zj(i,2+ior)=w(i)
		  call multmat(x2,zj,x9,ipmax,nmax,ior,icnt,2+ior)
		  call multmat(x5,x9,x10,nmax,ipmax,icnt,ior,2+ior)                  
		  call addmat(zj,x10,zzj,nmax,icnt,2+ior,-1)
		  call trnmat(zzj,zzj1,nmax,ipmax,icnt,2+ior)
		  call multmat(zzj1,zzj,x11,ipmax,nmax,ior+2,icnt,ior+2)
		  call matinv(x11,x12,elp2,ipmax,ior+2,ifail)      
		  call multmat(zzj1,x8,x13,ipmax,nmax,ior+2,icnt,2)
		  call multmat(x12,x13,x14,ipmax,ipmax,ior+2,ior+2,2)
		  call multmat(zzj,x14,x15,nmax,ipmax,icnt,ior+2,2)
		  call addmat(x8,x15,x18,nmax,icnt,2,-1)
		  call trnmat(x18,x16,nmax,2,icnt,2)
		  call multmat(x16,x18,x17,2,nmax,2,icnt,2)
		  do 130 i=1,2
		     do 130 j=1,2
 130                    x17(i,j)=x17(i,j)/real(icnt)
		  det=0.0
		  call zeromat(wk,2,2,2)
		  call detmtx(x17,wk,2,2,det)
		  det1(iz,ix)=(real(icnt)/2.0)*dlog(dble(det))
		  call zeromat(zj,nmax,nob,ipmax)
		  call zerovec(w,nmax,nob)
		  call zeromat(z,nmax,nob,ipmax)
		  call zeromat(x16,2,2,nob)
		  call zeromat(x17,2,2,2)
		  call zeromat(x12,ipmax,ipmax,ipmax)
		  call zeromat(x13,ipmax,ipmax,2)
		  call zeromat(x11,ipmax,ipmax,ipmax)
		  call zeromat(x14,ipmax,ipmax,2)
		  call zeromat(x9,ipmax,ipmax,ipmax)
		  call zeromat(x15,nmax,nob,2)
		  call zeromat(x18,nmax,nob,2)
		  call zeromat(x10,nmax,ipmax,ipmax)
		  call zeromat(zzj,nmax,nob,ipmax)
		  call zeromat(zzj1,ipmax,ipmax,nob)
		  call zeromat(elp1,ipmax,ipmax,ipmax)
		else
		  det1(iz,ix)=9.d+10
		endif
c              write(10,*) thr(nreg),det1(isim),isim
 910        continue
 900     continue
	 ibm=1
	 itm=1
	 detmin=det1(1,1)
	 do 920 i=1,inam
	   do 920 j=1,ipa
	      if (det1(i,j).lt.detmin) then
		 detmin=det1(i,j)
		 ibm=i
		 itm=j
	      endif
 920     continue
	 write(6,508) post(itm),bcan(ibm)
	 do 800 i=1,nob-1
 800        w2(i)=dat(i,1)-bcan(ibm)*dat(i,2)
	 n2=0
	 n3=0
	 do 810 i=2,nob
	    if(w2(i).le.post(itm)) then
		  n2=n2+1
	       do 820 j=1,2
		  d8(n2,j)=dat(i,j)                  
 820           continue
	    else
		  n3=n3+1
	       do 830 j=1,2
 830              d9(n3,j)=dat(i,j)
	       continue
	    endif
 810     continue
	 call reg(d8,nmax,n2,c2,desv2,0)
	 call reg(d9,nmax,n3,c3,desv3,0)
	 write(10,508) post(itm),bcan(ibm),c2(1),c3(1)
	 write(6,*) c2(1),c3(1)
	 call zeromat(d8,nmax,n2,2)
	 call zeromat(d9,nmax,n3,2)
	 call zeromat(y1,nmax,nob,ipmax)
	 call zeromat(x1,nmax,nob,ipmax)
	 call zeromat(x2,ipmax,ipmax,nob)
	 call zeromat(x3,ipmax,ipmax,ipmax)
	 call zeromat(x4,ipmax,ipmax,ipmax)
	 call zeromat(x5,nmax,nob,ipmax)
	 call zeromat(x6,ipmax,ipmax,2)
	 call zeromat(x7,nmax,nob,2)
	 call zeromat(x8,nmax,nob,2)
	 call zeromat(dat,nmax,nob,ipmax)
 930  continue
 508   format(f10.5,2x,f10.5,2x,f10.5,2x,f10.5,2x,f10.5)
      end       

      SUBROUTINE MULTMAT(AMAT,BMAT,CMAT,ID1MAX,ID2MAX,L1,L2,L3)
C**********************************************************************
C     PORPOSE: MATRIX MULTIPLICATION
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L2,L3
C     OUPUT: CMAT, MATRIX DIMENSION L1,L3
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      call zeromat(cmat,id1max,l1,l3)
      DO 99 J=1,L3
	 DO 98 K=1,L2
	    IF (BMAT(K,J).EQ.0.0) GOTO 98
	    DO 97 I=1,L1
	       CMAT(I,J)=CMAT(I,J)+AMAT(I,K)*BMAT(K,J)
   97       CONTINUE
   98    CONTINUE
   99 CONTINUE
      RETURN
      END

      SUBROUTINE MATINV(AMAT,BMAT,ELP,ID1MAX,L1,IFAIL)
C************************************************************************
C     PORPOSE: MATRIX INVERSION
C     INPUT: AMAT, MATRIX DIMENSION L1,L1
C     OUTPUT: BMAT, MATRIX DIMENSION L1,L1
C             IFAIL, MONITORING VALUE
C************************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),ELP(ID1MAX,*)
      EXTERNAL EQMAT,ZEROMAT
C     
      CALL ZEROMAT(ELP,ID1MAX,L1,L1)
      CALL EQMAT(AMAT,ELP,ID1MAX,ID1MAX,L1,L1)
      DO 115 I=1,L1
	 BMAT(I,I)=1.0
  115 CONTINUE
      DO 99 J=1,L1
	 DO 98 I=J,L1
	    IF (ELP(I,J).NE.0.0) GOTO 11
   98    CONTINUE
	 IFAIL=1
	 RETURN
   11    CONTINUE
      DO 97 K=1,L1
C
	 PIVOT01= ELP(J,K)
	 ELP(J,K)= ELP(I,K)
	 ELP(I,K)= PIVOT01
C
	 PIV= BMAT(J,K)
	 BMAT(J,K)=BMAT(I,K)
	 BMAT(I,K)= PIV
   97 CONTINUE
C
      IF(ELP(J,J).NE.0.0) GOTO 22
C
      IFAIL=1
      RETURN
C
C
   22 CONTINUE
      PPP= 1.0/ELP(J,J)
      DO 96 K=1,L1
C
	 ELP(J,K)= ELP(J,K)*PPP
	 BMAT(J,K)= BMAT(J,K)*PPP
   96 CONTINUE
C
      DO 95 K=1,L1
C
	 IF(J.EQ.K) THEN
C
   33       CONTINUE
C
	 ELSE
	    PPP= ELP(K,J)
	    DO 94 L=1,L1
C
	       ELP(K,L)=ELP(K,L)-ELP(J,L)*PPP
	       BMAT(K,L)=BMAT(K,L)-BMAT(J,L)*PPP
   94       CONTINUE
C
	 END IF
   95 CONTINUE
   99 CONTINUE
C
      RETURN
      END

     
      SUBROUTINE ZEROMAT(AMAT,ID1MAX,L1,L2)
C**************************************************************
C     PORPOSE: CREATE A MATRIX OF ZEROS
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: AMAT, ZEROED MATRIX DIMENSION L1,L2
C**************************************************************
      
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*)
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    AMAT(I,J)=0.0
  99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ZEROVEC(VEC,ID1MAX,L1)
C**************************************************************
C     PORPOSE: CREATE A VECTOR OF ZEROS      
C     INPUT: VEC, VECTOR DIMENSION L1
C     OUTPUT: VEC, ZEROED VECTOR DIMENSION L1
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEC(ID1MAX)

      DO 98 I=1,L1     
		VEC(I)=0.0
  98  CONTINUE
      RETURN
	END
   
      SUBROUTINE EQMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C**************************************************************
C     PORPOSE: EQUALIZATION OF MATRICES 
C     INPUT: AMAT, MATRIX DIMENSION L1 L2
C     OUPUT: BMAT, MATRIX EQUAL AMAT DIMENSION L1 L2
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
      external zeromat
      call zeromat(bmat,id2max,l1,l2)
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    BMAT(I,J)=AMAT(I,J)
   99    CONTINUE
   98 CONTINUE
      RETURN
      END

      SUBROUTINE EQVEC(VECA,VECB,ID1MAX,L1)
C******************************************************************
C     PORPOSE: EQUALIZATION OF VECTORS
C     INPUT: VECA, VECTOR DIMENSION L1
C     OUTPUT: VECB, VECTOR EQUAL VECA DIMENSON L1
C******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VECA(ID1MAX),VECB(ID1MAX)
C
      DO 99 I=1,L1
	    VECB(I)=VECA(I)
   99 CONTINUE
      RETURN
      END

      SUBROUTINE TRNMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C********************************************************************
C     PORPOSE: TRANSPOSE A MATRIX OF DIMENSION L1,L2
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: BMAT, TRANSPOSED MATRIX DIMENSION L2,L1
C********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
      external zeromat
      call zeromat(bmat,id2max,l2,l1)
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    BMAT(J,I)=AMAT(I,J)
   99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ADDMAT(AMAT,BMAT,CMAT,ID1MAX,L1,L2,IND)
C**********************************************************************
C     PORPOSE: MATRIX SUM
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L1,L2
C            IND,  INDICATOR VARIABLE: 1, ADD
C                                     -1, EXTRACT
C     OUPUT: CMAT, MATRIX DIMENSION L1,L2
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      CALL ZEROMAT(CMAT,ID1MAX,L1,L3)
      DO 2 J=1,L1
	 DO 2 K=1,L2
 2          CMAT(J,K)=AMAT(J,K)+IND*BMAT(J,K)
      RETURN
      END

      SUBROUTINE reg(dat,ID1MAX,nob,coef,desv,icf)
C**********************************************************************
C     PORPOSE: OLS ESTIMATES (NON RESTRICTED)
C**********************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION dat(ID1MAX,*),coef(*),dat1(250,3),dat2(3,250),dat3(3,3)
      dimension dat4(3,3),dat5(3,250),y(250,1),elp2(3,3),desv(*)
      dimension dat6(250,3)
      external multmat,matinv,trnmat,zeromat,zerovec
      s1=0.0
      s2=0.0
      s3=0.0
      call zeromat(dat1,250,250,3)
      call zeromat(dat2,3,3,250)
      call zeromat(dat3,3,3,3)
      call zeromat(dat4,3,3,3)
      call zeromat(dat5,3,3,250)
      call zerovec(coef,3,3)
      call zerovec(desv,3,3)
      call zeromat(dat6,250,250,3)
      call zeromat(y,250,250,1)
      do 100 i=1,nob
	 y(i,1)=dat(i,1)
	 if (icf.eq.1) dat1(i,1)=1.0
 100     dat1(i,1+icf)=dat(i,2)
      call trnmat(dat1,dat2,250,3,nob,1+icf)
      call multmat(dat2,dat1,dat3,3,250,1+icf,nob,1+icf)
      call matinv(dat3,dat4,elp2,3,1+icf,ifail)
      call multmat(dat4,dat2,dat5,3,3,1+icf,1+icf,nob)
      call multmat(dat5,y,coef,3,250,1+icf,nob,1)
      err=0.0
      call multmat(dat1,coef,dat6,250,3,nob,1+icf,1)
      do 110 i=1,nob
 110     err=err+(y(i,1)-dat6(i,1))**2
      xse=err/real(nob-(1+icf))
      do 120 i=1,icf+1
 120    desv(i)=sqrt(dat4(i,i)*xse)      
      end

      SUBROUTINE PCAND(X,N,CTHD,IPL,IPU,IPR)
C**************************************************************
C DEFINES CANDIDATE THRESHOLD VALUES FOR INFLATION RATES
C THRESHOLD VALUES ARE SEARCHED AMONG THE INTERPERCENTILE RANGE
C @ EQUIWIDTH INTERVALS ( # INTERVALS = # VALUES BETWEEN PERC)
C X = MATRIX OF DATA
C N = # DATA
C CTHD = ARRAY OF CANDIDATE THRESHOLD VALUES
C IPL = USER-SUPPLIED LOWER PERCENTILE
C IPU = USER-SUPPLIED UPPER PERCENTILE
C EXTERNAL SUBROUTINE = QCKSRT
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 IPL,IPU
      DIMENSION X(*),CTHD(*),SARR(1000)
      EXTERNAL QCKSRT
      DO 12 I=1,N
 12      SARR(I)=X(I)
      CALL QCKSRT(N,SARR)
      IP1=NINT(IPL*N)
      AMIN=SARR(IP1)
      IP2=NINT(IPU*N)
      AMAX=SARR(IP2)
      IPR=IP2-IP1
      AI=AMAX-AMIN
      AINC=AI/REAL(IPR)
      CTHD(1)=AMIN
      DO 13 J=2,IPR
 13      CTHD(J)=CTHD(J-1)+AINC
      RETURN
      END

C#####################################################
C Quicksort routine from numerical recipes
C#####################################################
      SUBROUTINE QCKSRT(N,ARR)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (M=7,NSTACK=50,FM=7875.,FA=211.,FC=1663.
     *    ,FMI=1.2698413E-4,maxdat=1000)
      DIMENSION ISTACK(NSTACK)
      DIMENSION ARR(maxdat)
C     DOUBLE PRECISION A
      JSTACK=0
      L=1
      IR=N
      FX=0.
10    IF(IR-L.LT.M)THEN
	DO 13 J=L+1,IR
	  A=ARR(J)
	  DO 11 I=J-1,1,-1
	    IF(ARR(I).LE.A)GO TO 12
	    ARR(I+1)=ARR(I)
11        CONTINUE
	  I=0
12        ARR(I+1)=A
13      CONTINUE
	IF(JSTACK.EQ.0)RETURN
	IR=ISTACK(JSTACK)
	L=ISTACK(JSTACK-1)
	JSTACK=JSTACK-2
      ELSE
	I=L
	J=IR
	FX=MOD(FX*FA+FC,FM)
	IQ=L+(IR-L+1)*(FX*FMI)
	A=ARR(IQ)
	ARR(IQ)=ARR(L)
20      CONTINUE
21        IF(J.GT.0)THEN
	    IF(A.LT.ARR(J))THEN
	      J=J-1
	      GO TO 21
	    ENDIF
	  ENDIF
	  IF(J.LE.I)THEN
	    ARR(I)=A
	    GO TO 30
	  ENDIF
	  ARR(I)=ARR(J)
	  I=I+1
22        IF(I.LE.N)THEN
	    IF(A.GT.ARR(I))THEN
	      I=I+1
	      GO TO 22
	    ENDIF
	  ENDIF
	  IF(J.LE.I)THEN
	    ARR(J)=A
	    I=J
	    GO TO 30
	  ENDIF
	  ARR(J)=ARR(I)
	  J=J-1
	GO TO 20
30      JSTACK=JSTACK+2
	IF(JSTACK.GT.NSTACK)PAUSE 'NSTACK must be made larger.'
	IF(IR-I.GE.I-L)THEN
	  ISTACK(JSTACK)=IR
	  ISTACK(JSTACK-1)=I+1
	  IR=I-1
	ELSE
	  ISTACK(JSTACK)=I-1
	  ISTACK(JSTACK-1)=L
	  L=I+1
	ENDIF
      ENDIF
      GO TO 10
      END

       subroutine gnorm(r,nr,rs)
C       IMPLICIT REAL (A-H,O-Z)
       integer nr,rs
       real*8 r(*)
       do  1 i=1,nr
99        continue         
	  v=randu(rs)*2.-1.
	  u=randu(rs)*2.-1.
	  w=v*v+u*u
	  if(w.gt.1)goto 99
	  c=sqrt(-2.*alog(w)/w)
	  R(i)=c*v
	  r(i+1)=c*u
1      continue
       return
       end                      
		   
C**************************************************************************  
C  
      REAL FUNCTION RANDU(IX)  
C  
C UNIFORM RANDOM NUMBER GENERATOR.  
C REF: SCHRAGE, L. 1979 'A MORE PORTABLE FORTRAN RANDOM NUMBER GENERATOR'  
C      A. C. M. TRANSACTIONS ON MATHEMATICAL SOFTWARE V5 132-138.  
C  
      INTEGER A,P,IX,B15,B16,XHI,XALO,LEFTLO,FHI,K  
      DATA A/16807/,B15/32768/,B16/65536/,P/2147483647/  
      XHI=IX/B16  
      XALO=(IX-XHI*B16)*A  
      LEFTLO=XALO/B16  
      FHI=XHI*A+LEFTLO  
      K=FHI/B15  
      IX=(((XALO-LEFTLO*B16)-P)+(FHI-K*B15)*B16)+K  
      IF (IX.LT.0) IX=IX+P  
      RANDU=FLOAT(IX)*4.656612875E-10  
      RETURN  
      END  
C

c*****************************************
       subroutine detmtx(a,wk,mx,k,det)
c
c---- This program computes the determinant of a covariance matrix.
c     It assumes that the variance of each variable is not close to zero.
c     The program transforms the mtx into an upper triangular one.
c
       real*8 a(mx,mx), det, tem, wk(mx,mx), crit
       integer mx, k, i, j, km1
c--------- wk(.,.) is a working area.
c
       if(k.eq.1)then
	det = a(1,1)
	return
       endif
c
       km1 = k-1
       crit = 1.0d-15
c
       do 10 i=1, k
	do 10 j=1, k
 10        wk(i,j) = a(i,j)
c
       do 50 i=1, km1
	if(dabs(a(i,i)).le.crit)then 
	 det = 0.0d0
	 return
	endif
	tem = wk(i+1,i)/a(i,i)
	do 40 j=i+1, k
 40       wk(i+1,j) = wk(i+1,j)-wk(i,j)*tem
 50      continue
c
       det = 1.0d0
       do 60 i=1, k
 60       det = det*wk(i,i)
c
cc       print*,'det = ', det
c
       return
       end
